# Created by Topology-Converter v{{ version }}
#    Template Revision: v4.7.1
#    https://gitlab.com/cumulus-consulting/tools/topology_converter
#    using topology data from: {{ topology_file }}
#    built with the following args: {{ arg_string }}
#
#    NOTE: in order to use this Vagrantfile you will need:
#       -Vagrant(v2.0.2+) installed: http://www.vagrantup.com/downloads
#       -the "helper_scripts" directory that comes packaged with topology-converter.py
{% if provider == 'virtualbox' %}#       -Virtualbox installed: https://www.virtualbox.org/wiki/Downloads

{% elif provider == 'libvirt' %}#        -Libvirt Installed -- guide to come
#       -Vagrant-Libvirt Plugin installed: $ vagrant plugin install vagrant-libvirt
#       -Start with \"vagrant up --provider=libvirt --no-parallel\n")

#  Libvirt Start Port: {{start_port}}
#  Libvirt Port Gap: {{port_gap}}

#Set the default provider to libvirt in the case they forget --provider=libvirt or if someone destroys a machine it reverts to virtualbox
ENV['VAGRANT_DEFAULT_PROVIDER'] = 'libvirt'

# Check required plugins
REQUIRED_PLUGINS_LIBVIRT = %w(vagrant-libvirt)
exit unless REQUIRED_PLUGINS_LIBVIRT.all? do |plugin|
  Vagrant.has_plugin?(plugin) || (
    puts "The #{plugin} plugin is required. Please install it with:"
    puts "$ vagrant plugin install #{plugin}"
    false
  )
end{% endif %}

Vagrant.require_version ">= 2.0.2"

# Fix for Older versions of Vagrant to Grab Images from the Correct Location
unless Vagrant::DEFAULT_SERVER_URL.frozen?
  Vagrant::DEFAULT_SERVER_URL.replace('https://vagrantcloud.com')
end

$script = <<-SCRIPT
function setup_ztp(){
    echo "### Disabling ZTP service..."
    systemctl stop ztp.service
    ztp -d 2>&1
    echo "### Resetting ZTP to work next boot..."
    ztp -R 2>&1
    ztp -i &> /dev/null

    if [ -e /tmp/cumulus-ztp ]; then
        echo "  ### Found ZTP Script, moving into preload directory... ###"
        mv /tmp/cumulus-ztp /var/lib/cumulus/ztp/cumulus-ztp
        chmod +x /var/lib/cumulus/ztp/cumulus-ztp
        ls -lha /var/lib/cumulus/ztp/cumulus-ztp
    fi
}

function disable_remap(){
    echo "### Disabling default remap on Cumulus VX..."
    if [ -f /etc/hw_init.d/S10rename_eth_swp.sh ]; then
        chmod -x /etc/hw_init.d/S10rename_eth_swp.sh
    fi
}

function vagrant_user_nclu(){
    echo "### Giving Vagrant User Ability to Run NCLU Commands ###"
    adduser vagrant netedit
    adduser vagrant netshow
}

function vagrant_user_nvue(){
    echo "### Giving Vagrant User Ability to Run NVUE Commands ###"
    adduser vagrant nvapply
}

if grep -q -i 'cumulus' /etc/lsb-release &> /dev/null; then
    echo "### RUNNING CUMULUS EXTRA CONFIG ###"
    source /etc/lsb-release
    echo "  INFO: Detected Cumulus Linux v$DISTRIB_RELEASE Release"
    if [ -e /etc/app-release ]; then
        echo "  INFO: Detected NetQ TS Server"
        source /etc/app-release
        echo "  INFO: Running NetQ TS Appliance Version $APPLIANCE_VERSION"
        disable_remap
        vagrant_user_nclu
        setup_ztp
    else
        if [[ $DISTRIB_RELEASE =~ ^2.* ]]; then
            echo "  INFO: Detected a 2.5.x Based Release"
            echo "     2.5.x: adding fake cl-acltool..."
            echo -e "#!/bin/bash\nexit 0" > /usr/bin/cl-acltool
            chmod 755 /usr/bin/cl-acltool
            echo "     2.5.x: adding fake cl-license..."
            echo -e "#!/bin/bash\nexit 0" > /usr/bin/cl-license
            chmod 755 /usr/bin/cl-license
            echo "     2.5.x: Disabling default remap on Cumulus VX..."
            mv -v /etc/init.d/rename_eth_swp /etc/init.d/rename_eth_swp.backup
        elif [[ $DISTRIB_RELEASE =~ ^3.* ]]; then
            echo "  INFO: Detected a 3.x Based Release ($DISTRIB_RELEASE)"
            echo "### Disabling default remap on Cumulus VX..."
            mv -v /etc/hw_init.d/S10rename_eth_swp.sh /etc/S10rename_eth_swp.sh.backup &> /dev/null
            if [[ $DISTRIB_RELEASE =~ ^3.[1-9].* ]]; then
                echo "### Fixing ONIE DHCP to avoid Vagrant Interface ###"
                echo "     Note: Installing from ONIE will undo these changes."
                mkdir /tmp/foo
                mount LABEL=ONIE-BOOT /tmp/foo
                sed -i 's/eth0/eth1/g' /tmp/foo/grub/grub.cfg
                sed -i 's/eth0/eth1/g' /tmp/foo/onie/grub/grub-extra.cfg
                umount /tmp/foo
            fi
            if [[ $DISTRIB_RELEASE =~ ^3.2.* ]]; then
                if [[ $(grep "vagrant" /etc/netd.conf | wc -l ) == 0 ]]; then
                    echo "### Giving Vagrant User Ability to Run NCLU Commands ###"
                    sed -i 's/users_with_edit = root, cumulus/users_with_edit = root, cumulus, vagrant/g' /etc/netd.conf
                    sed -i 's/users_with_show = root, cumulus/users_with_show = root, cumulus, vagrant/g' /etc/netd.conf
                fi
            elif [[ $DISTRIB_RELEASE =~ ^3.[3-9].* ]]; then
                vagrant_user_nclu
            fi
            setup_ztp
        elif [[ $DISTRIB_RELEASE =~ ^4.* ]]; then
            echo "  INFO: Detected a 4.x Based Release ($DISTRIB_RELEASE)"
            disable_remap
            vagrant_user_nclu
            setup_ztp
        elif [[ $DISTRIB_RELEASE =~ ^5.* ]]; then
            echo "  INFO: Detected a 5.x Based Release ($DISTRIB_RELEASE)"
            disable_remap
            vagrant_user_nvue
            setup_ztp
        fi
    fi
fi
echo "### DONE ###"
echo "### Rebooting Device to Apply Remap..."
nohup bash -c 'sleep 10; shutdown now -r "Rebooting to Remap Interfaces"' &
SCRIPT

$script_ansible_key = <<-SCRIPT
SSH_URL="http://192.168.200.254/authorized_keys"
echo "Setup SSH key authentication for Ansible"
mkdir -p /home/cumulus/.ssh
wget -O /home/cumulus/.ssh/authorized_keys $SSH_URL
SCRIPT


Vagrant.configure("2") do |config|
  config.ssh.forward_agent = true
  VAGRANT_COMMAND = ARGV[0]

{% if provider == 'virtualbox' %}
  simid = {{ epoch_time }}

  config.vm.provider "virtualbox" do |v|
    v.gui=false
{% elif provider == 'libvirt' %}
  wbid = 1
  offset = wbid * 100
{%   if libvirt_prefix != None %}
  config.vm.provider :libvirt do |libvirt|
    libvirt.default_prefix = '{{ libvirt_prefix }}'
  end
{%   endif %}

  config.vm.provider :libvirt do |domain|
    domain.management_network_address = "10.255.#{wbid}.0/24"
    domain.management_network_name = "wbr#{wbid}"
    # increase nic adapter count to be greater than 8 for all VMs.
    domain.nic_adapter_count = 130{% endif %}
  end

{% if generate_ansible_hostfile == True %}
  #Generating Ansible Host File at following location:
  #    ./.vagrant/provisioners/ansible/inventory/vagrant_ansible_inventory
  config.vm.provision "ansible" do |ansible|
    ansible.playbook = "./helper_scripts/empty_playbook.yml"
{% if function_group is defined -%}
    # ANSIBLE GROUPS CONFIGURATION
    ansible.groups = {
{%- for function in function_group %}
      "{{ function }}" => [{% for device in function_group[function] %}"{{device}}",{% endfor %}],{% endfor %}
      "network:children" => [{% for function in function_group%}{% if function in network_functions%}"{{function}}",{% endif %}{% endfor %}]
    }
{%- endif %}
  end{% endif %}

{% for device in devices %}
  ##### DEFINE VM for {{ device.hostname }} #####
  config.vm.define "{{ device.hostname }}" do |device|
    {% if device.legacy is not defined %}
    device.vm.hostname = "{{ device.hostname }}"
    {% endif %}{% if device.pxehost=="True" %}
    device.ssh.insert_key = false
    {%  if provider == 'libvirt'%}
    #NO BOX USED FOR PXE DEVICE{% else %}
    device.vm.box = "{{ device.os }}"{% endif %}{% else %}
    device.vm.box = "{{ device.os }}"{% if device.version %}
    device.vm.box_version = "{{ device.version }}"{% endif %}{% endif %}{% if device.vagrant_user %}
    if VAGRANT_COMMAND == "ssh" or VAGRANT_COMMAND == "scp"
      device.ssh.username = "{{ device.vagrant_user }}"
    end{% endif %}
{% if provider == 'virtualbox' %}    device.vm.provider "virtualbox" do |v|
      v.name = "#{simid}_{{ device.hostname }}"
      v.customize ["modifyvm", :id, '--audiocontroller', 'AC97', '--audio', 'Null']{% elif provider == 'libvirt' %}
    device.vm.provider :libvirt do |v|{% if device.pxehost=="True" %}
      v.storage :file, :size => '100G', :type => 'qcow2', :bus => 'sata', :device => 'sda'
      v.boot 'hd'
      v.boot 'network'{% endif %}{% if device.function == 'host' %}
      v.nic_model_type = 'e1000' {% endif %}{% endif %}
{% if device.memory is defined %}      v.memory = {{ device.memory }}{% endif %}
{% if device.cpu is defined %}      v.cpus = {{ device.cpu }}{% endif %}
    end{% if synced_folder == False %}
    #   see note here: https://github.com/pradels/vagrant-libvirt#synced-folders
    device.vm.synced_folder ".", "/vagrant", disabled: true{% endif %}

{% if device.ssh_port is defined %}    # SSH Port
    device.vm.network :forwarded_port, guest: 22, host: {{ device.ssh_port }}, host_ip: "0.0.0.0", id: "ssh", auto_correct:true
{%- endif %}

    # NETWORK INTERFACES{% for link in device.interfaces %}
      # link for {{ link.local_interface }} --> {{ link.remote_device }}:{{ link.remote_interface }}
      {% if provider == 'virtualbox' %}device.vm.network "private_network", virtualbox__intnet: "#{simid}_{{ link.network }}", auto_config: false , :mac => "{{ link.mac|replace(':', '') }}"
      {% elif provider == 'libvirt' %}device.vm.network "private_network",
            :mac => "{{ link.mac }}",
            :libvirt__tunnel_type => 'udp',
            :libvirt__tunnel_local_ip => '{{ link.local_ip }}',
            :libvirt__tunnel_local_port => "#{ {{ link.local_port }} + offset }",
            :libvirt__tunnel_ip => '{{ link.remote_ip }}',
            :libvirt__tunnel_port => "#{ {{ link.remote_port }} + offset }",
            :libvirt__iface_name => '{{ link.local_interface }}',
            auto_config: false{% endif %}{% endfor %}

{% if provider == 'virtualbox' %}    device.vm.provider "virtualbox" do |vbox|{% for i in range(2, 2+device.interfaces.__len__()) %}
      vbox.customize ['modifyvm', :id, '--nicpromisc{{i}}', 'allow-all']{% endfor %}
      vbox.customize ["modifyvm", :id, "--nictype1", "virtio"]{% if device.pxehost=="True" %}

      # Setup Interfaces for PXEBOOT
        # Adding network as a boot option.
        vbox.customize ["modifyvm", :id, "--boot4", "net"]

        # Setting Vagrant interface to lowest boot preference
        vbox.customize ["modifyvm", :id, "--nicbootprio1", "0"]
{% for link in device.interfaces %}{% if link.pxebootinterface %}{% if link.pxebootinterface == "True" %}
        # Setting Specified interface to highest preference.
        vbox.customize ["modifyvm", :id, "--nicbootprio{{loop.index+1}}", "1"]{% endif %}{% endif %}{% endfor %}{% endif %}
    end{% endif %}

    {% if "ubuntu" in device.os.lower() -%}
    # Shorten Boot Process - Applies to Ubuntu Only - remove \"Wait for Network\"
    device.vm.provision :shell , inline: "sed -i 's/sleep [0-9]*/sleep 1/' /etc/init/failsafe.conf 2>/dev/null || true"

    # Enable serial console
    device.vm.provision :shell , inline: "sudo systemctl enable serial-getty@ttyS0"
    device.vm.provision :shell , inline: "sudo systemctl start serial-getty@ttyS0"

    {% endif -%}
{% if device.function == "oob-server" and create_mgmt_device -%}
    # Copy over DHCP files and MGMT Network Files
    device.vm.provision "file", source: "{{ mgmt_destination_dir }}dhcpd.conf", destination: "~/dhcpd.conf"
    device.vm.provision "file", source: "{{ mgmt_destination_dir }}dhcpd.hosts", destination: "~/dhcpd.hosts"
    device.vm.provision "file", source: "{{ mgmt_destination_dir }}hosts", destination: "~/hosts"
    device.vm.provision "file", source: "{{ mgmt_destination_dir }}ansible_hostfile", destination: "~/ansible_hostfile"
    device.vm.provision "file", source: "{{ mgmt_destination_dir }}cumulus-ztp", destination: "~/cumulus-ztp"
    device.vm.provision "file", source: "{{ mgmt_destination_dir }}ssh_config", destination: "~/ssh_config"
{% endif -%}
{% if "cumulus-vx" in device.os -%}

    # Copy over Topology.dot File
    device.vm.provision "file", source: "{{ topology_file }}", destination: "~/topology.dot"
    device.vm.provision :shell, privileged: false, inline: "sudo mv ~/topology.dot /etc/ptm.d/topology.dot"

{% endif -%}

{% if device.function == "oob-switch" and create_mgmt_device %}
      # Transfer Bridge File
      device.vm.provision "file", source: "{{ mgmt_destination_dir }}bridge-untagged", destination: "~/bridge-untagged"
{% endif -%}

{% if device.config is defined %}
    # Run the Config specified in the Node Attributes
    device.vm.provision :shell , privileged: false, :inline => 'echo "$(whoami)" > /tmp/normal_user'
    device.vm.provision :shell , path: "{{ device.config }}"
{% endif %}

    # Install Rules for the interface re-map
    {% if device.pxehost=="True" and provider == 'libvirt' -%}
      # NO REMAP for LIBVIRT PXE DEVICE
    {% elif device.remap=="False" -%}
      # REMAP Disabled for this node
    {% else -%}
    device.vm.provision :shell , :inline => <<-delete_udev_directory
if [ -d "/etc/udev/rules.d/70-persistent-net.rules" ]; then
    rm -rfv /etc/udev/rules.d/70-persistent-net.rules &> /dev/null
fi
rm -rfv /etc/udev/rules.d/70-persistent-net.rules &> /dev/null
delete_udev_directory

{% for link in device.interfaces -%}

      device.vm.provision :shell , :inline => <<-udev_rule
echo "  INFO: Adding UDEV Rule: {{ link.mac }} --> {{ link.local_interface }}"
echo 'ACTION=="add", SUBSYSTEM=="net", ATTR{address}=="{{ link.mac }}", NAME="{{ link.local_interface }}", SUBSYSTEMS=="pci"' >> /etc/udev/rules.d/70-persistent-net.rules
udev_rule
     {% endfor %}
      device.vm.provision :shell , :inline => <<-vagrant_interface_rule
echo "  INFO: Adding UDEV Rule: Vagrant interface = {% if device.vagrant %}{{ device.vagrant }}{%else%}vagrant{% endif%}"
echo 'ACTION=="add", SUBSYSTEM=="net", ATTR{ifindex}=="2", NAME="{% if device.vagrant %}{{ device.vagrant }}{%else%}vagrant{% endif%}", SUBSYSTEMS=="pci"' >> /etc/udev/rules.d/70-persistent-net.rules
echo "#### UDEV Rules (/etc/udev/rules.d/70-persistent-net.rules) ####"
cat /etc/udev/rules.d/70-persistent-net.rules
vagrant_interface_rule

{% endif -%}

{% if device.playbook is defined %}
    # Ansible Playbook Configuration
    device.vm.provision "ansible" do |ansible|
          ansible.playbook = "{{ device.playbook }}"
{%- if function_group is defined %}
          # ANSIBLE GROUPS CONFIGURATION
          ansible.groups = {
{%- for function in function_group%}
            "{{ function }}" => [{% for device in function_group[function] %}"{{device}}",{% endfor %}],
{%- endfor %}
            "network:children" => [{% for function in function_group%}{% if function in network_functions%}"{{function}}",{% endif %}{% endfor %}]
          }
{%- endif %}
    end
{% endif -%}

{% if device.pxehost=="True" and provider == 'libvirt' -%}

    # NO REMAP APPLICATION for LIBVIRT PXE DEVICE
{% elif device.remap=="False" -%}

    # NO REMAP APPLICATION Required

{% else -%}

{%   if 'ztp' in device %}
    # Copy over ZTP Script
    device.vm.provision "file", source: "{{ device.ztp }}", destination: "/tmp/cumulus-ztp"
    device.vm.provision :shell , :inline => <<-ztp_push_check
echo "  INFO: Pushing ZTP Script to node."
ls -lha /tmp/cumulus-ztp
ztp_push_check
{%   endif %}

{%  if device.function == "oob-server" or device.function == "host" %}

    # Reboot the box to apply interface re-map (udev rules)
    device.vm.provision 'shell', reboot: true
{%  else %}
    # Run Any Platform Specific Code and Apply the interface Re-map
    #   (may or may not perform a reboot depending on platform)
    device.vm.provision :shell , :inline => $script
    device.vm.provision 'shell', reboot: true
{%  endif %}
{% endif -%}

{%  if device.function == "host" %}
    device.vm.provision :shell , :inline => $script_ansible_key
{%  endif %}

  end
{% endfor %}


end
